#include <dlfcn.h>

#include <iostream>

using namespace std;

int main()
{
	typedef void( *PluginFunction )();

	void *pluginHandle = dlopen( "./plugin.o", RTLD_LAZY );
	if ( !pluginHandle ) {
		cerr << dlerror() << endl;
		return 1;
	}

	PluginFunction pluginFunction = ( PluginFunction )dlsym( pluginHandle, "entry" );

	const char *error = dlerror();
	if ( error ) {
		cerr << error << endl;
		return 1;
	}

	pluginFunction();

	dlclose( pluginHandle );
}


